all: lib$(LIB).a $(TESTS)

%: %.o lib$(LIB).a
	$(CXX) -o $@ $< -L. -l $(LIB)

lib$(LIB).a: $(LIBOBJ)
	$(AR) -rcs $@ -- $(LIBOBJ)

clean:
	rm -f -- $(LIBOBJ) $(TESTS) $(TESTS:=.o)

check: $(TESTS)
	for name in $(TESTS); do echo ./$$name; ./$$name; done

.SUFFIXES:
.SECONDARY:
%.o: %.cpp .deps
	$(CXX) $(CXXFLAGS) -c -o $@ $< -MMD -MP -MF .deps/$*.d

# subtle: directories are listed as changed when entries are
# created, leading to spurious rebuilds.
.deps/stamp:
	mkdir .deps && touch/stamp

-include .deps/*.d
